Index: ruby-2.5.9/test/rexml/parser/test_ultra_light.rb
===================================================================
--- ruby-2.5.9.orig/test/rexml/parser/test_ultra_light.rb
+++ ruby-2.5.9/test/rexml/parser/test_ultra_light.rb
@@ -3,67 +3,66 @@ require "test/unit"
 require "rexml/parsers/ultralightparser"
 
 module REXMLTests
-class TestUltraLightParser < Test::Unit::TestCase
-  class TestDocumentTypeDeclaration < self
-    def test_entity_declaration
-      assert_equal([
-                     [
-                       :start_doctype,
-                       :parent,
-                       "root",
-                       "SYSTEM",
-                       "urn:x-test",
-                       nil,
-                       [:entitydecl, "name", "value"]
+  class TestUltraLightParser < Test::Unit::TestCase
+    class TestDocumentTypeDeclaration < self
+      def test_entity_declaration
+        assert_equal([
+                       [
+                         :start_doctype,
+                         :parent,
+                         "root",
+                         "SYSTEM",
+                         "urn:x-test",
+                         nil,
+                         [:entitydecl, "name", "value"]
+                       ],
+                       [:start_element, :parent, "root", {}],
                      ],
-                     [:start_element, :parent, "root", {}],
-                     [:text, "\n"],
-                   ],
-                   parse(<<-INTERNAL_SUBSET))
+                     parse(<<-INTERNAL_SUBSET))
 <!ENTITY name "value">
-      INTERNAL_SUBSET
-    end
+        INTERNAL_SUBSET
+      end
 
-    private
-    def xml(internal_subset)
-      <<-XML
+      private
+      def xml(internal_subset)
+        <<-XML
 <!DOCTYPE root SYSTEM "urn:x-test" [
 #{internal_subset}
 ]>
 <root/>
-      XML
-    end
+        XML
+      end
 
-    def parse(internal_subset)
-      parser = REXML::Parsers::UltraLightParser.new(xml(internal_subset))
-      normalize(parser.parse)
-    end
+      def parse(internal_subset)
+        parser = REXML::Parsers::UltraLightParser.new(xml(internal_subset))
+        normalize(parser.parse)
+      end
 
-    def normalize(root)
-      root.collect do |child|
-        normalize_child(child)
+      def normalize(root)
+        root.collect do |child|
+          normalize_child(child)
+        end
       end
-    end
 
-    def normalize_child(child)
-      tag = child.first
-      case tag
-      when :start_doctype
-        normalized_parent = :parent
-        normalized_doctype = child.dup
-        normalized_doctype[1] = normalized_parent
-        normalized_doctype
-      when :start_element
-        tag, parent, name, attributes, *children = child
-        normalized_parent = :parent
-        normalized_children = children.collect do |sub_child|
-          normalize_child(sub_child)
+      def normalize_child(child)
+        tag = child.first
+        case tag
+        when :start_doctype
+          normalized_parent = :parent
+          normalized_doctype = child.dup
+          normalized_doctype[1] = normalized_parent
+          normalized_doctype
+        when :start_element
+          tag, _parent, name, attributes, *children = child
+          normalized_parent = :parent
+          normalized_children = children.collect do |sub_child|
+            normalize_child(sub_child)
+          end
+          [tag, normalized_parent, name, attributes, *normalized_children]
+        else
+          child
         end
-        [tag, normalized_parent, name, attributes, *normalized_children]
-      else
-        child
       end
     end
   end
 end
-end
Index: ruby-2.5.9/test/rexml/parser/test_xpath.rb
===================================================================
--- /dev/null
+++ ruby-2.5.9/test/rexml/parser/test_xpath.rb
@@ -0,0 +1,127 @@
+# frozen_string_literal: false
+
+require "test/unit"
+require "rexml/parsers/xpathparser"
+
+module REXMLTests
+  class TestXPathParser < Test::Unit::TestCase
+    def self.sub_test_case(name, &block)
+      parent_test_case = self
+      sub_test_case = Class.new(self) do
+        singleton_class = class << self; self; end
+        singleton_class.__send__(:define_method, :name) do
+          [parent_test_case.name, name].compact.join("::")
+        end
+      end
+      sub_test_case.class_eval(&block)
+      sub_test_case
+    end
+
+    sub_test_case("#abbreviate") do
+      def abbreviate(xpath)
+        parser = REXML::Parsers::XPathParser.new
+        parser.abbreviate(xpath)
+      end
+
+      def test_document
+        assert_equal("/",
+                     abbreviate("/"))
+      end
+
+      def test_descendant_or_self_only
+        assert_equal("//",
+                     abbreviate("/descendant-or-self::node()/"))
+      end
+
+      def test_descendant_or_self_absolute
+        assert_equal("//a/b",
+                     abbreviate("/descendant-or-self::node()/a/b"))
+      end
+
+      def test_descendant_or_self_relative
+        assert_equal("a//b",
+                     abbreviate("a/descendant-or-self::node()/b"))
+      end
+
+      def test_descendant_or_self_not_node
+        assert_equal("/descendant-or-self::text()",
+                     abbreviate("/descendant-or-self::text()"))
+      end
+
+      def test_self_absolute
+        assert_equal("/a/./b",
+                     abbreviate("/a/self::node()/b"))
+      end
+
+      def test_self_relative
+        assert_equal("a/./b",
+                     abbreviate("a/self::node()/b"))
+      end
+
+      def test_self_not_node
+        assert_equal("/self::text()",
+                     abbreviate("/self::text()"))
+      end
+
+      def test_parent_absolute
+        assert_equal("/a/../b",
+                     abbreviate("/a/parent::node()/b"))
+      end
+
+      def test_parent_relative
+        assert_equal("a/../b",
+                     abbreviate("a/parent::node()/b"))
+      end
+
+      def test_parent_not_node
+        assert_equal("/a/parent::text()",
+                     abbreviate("/a/parent::text()"))
+      end
+
+      def test_any_absolute
+        assert_equal("/*/a",
+                     abbreviate("/*/a"))
+      end
+
+      def test_any_relative
+        assert_equal("a/*/b",
+                     abbreviate("a/*/b"))
+      end
+
+      def test_following_sibling_absolute
+        assert_equal("/following-sibling::a/b",
+                     abbreviate("/following-sibling::a/b"))
+      end
+
+      def test_following_sibling_relative
+        assert_equal("a/following-sibling::b/c",
+                     abbreviate("a/following-sibling::b/c"))
+      end
+
+      def test_predicate_index
+        assert_equal("a[5]/b",
+                     abbreviate("a[5]/b"))
+      end
+
+      def test_attribute_relative
+        assert_equal("a/@b",
+                     abbreviate("a/attribute::b"))
+      end
+
+      def test_filter_attribute
+        assert_equal("a/b[@i = 1]/c",
+                     abbreviate("a/b[attribute::i=1]/c"))
+      end
+
+      def test_filter_string_single_quote
+        assert_equal("a/b[@name = \"single ' quote\"]/c",
+                     abbreviate("a/b[attribute::name=\"single ' quote\"]/c"))
+      end
+
+      def test_filter_string_double_quote
+        assert_equal("a/b[@name = 'double \" quote']/c",
+                     abbreviate("a/b[attribute::name='double \" quote']/c"))
+      end
+    end
+  end
+end
Index: ruby-2.5.9/test/rexml/run.rb
===================================================================
--- /dev/null
+++ ruby-2.5.9/test/rexml/run.rb
@@ -0,0 +1,13 @@
+#!/usr/bin/env ruby
+
+$VERBOSE = true
+
+base_dir = File.dirname(File.expand_path(__dir__))
+lib_dir = File.join(base_dir, "lib")
+test_dir = File.join(base_dir, "test")
+
+$LOAD_PATH.unshift(lib_dir)
+
+require_relative "helper"
+
+exit(Test::Unit::AutoRunner.run(true, test_dir))
Index: ruby-2.5.9/test/rexml/test_attribute.rb
===================================================================
--- /dev/null
+++ ruby-2.5.9/test/rexml/test_attribute.rb
@@ -0,0 +1,12 @@
+module REXMLTests
+  class AttributeTest < Test::Unit::TestCase
+    def test_empty_prefix
+      error = assert_raise(ArgumentError) do
+        REXML::Attribute.new(":x")
+      end
+      assert_equal("name must be " +
+                   "\#{PREFIX}:\#{LOCAL_NAME} or \#{LOCAL_NAME}: <\":x\">",
+                   error.message)
+    end
+  end
+end
Index: ruby-2.5.9/test/rexml/test_attributes.rb
===================================================================
--- ruby-2.5.9.orig/test/rexml/test_attributes.rb
+++ ruby-2.5.9/test/rexml/test_attributes.rb
@@ -1,6 +1,4 @@
 # frozen_string_literal: false
-require 'test/unit/testcase'
-require 'rexml/document'
 
 module REXMLTests
   class AttributesTester < Test::Unit::TestCase
@@ -180,18 +178,27 @@ module REXMLTests
       attr_test('name','value with LF &#x000a; &amp; ampersand')
     end
 
-    def test_quoting
+    def test_quote_root
       d = Document.new(%q{<a x='1' y="2"/>})
       assert_equal( %q{<a x='1' y='2'/>}, d.to_s )
       d.root.context[:attribute_quote] = :quote
       assert_equal( %q{<a x="1" y="2"/>}, d.to_s )
+    end
 
+    def test_quote_sub_element
       d = Document.new(%q{<a x='1' y="2"><b z='3'/></a>})
       assert_equal( %q{<a x='1' y='2'><b z='3'/></a>}, d.to_s )
       d.root.context[:attribute_quote] = :quote
       assert_equal( %q{<a x="1" y="2"><b z="3"/></a>}, d.to_s )
     end
 
+    def test_quote_to_s_value
+      doc = Document.new(%q{<root a="'"/>}, {attribute_quote: :quote})
+      assert_equal(%q{<root a="'"/>}, doc.to_s)
+      assert_equal("'", doc.root.attribute("a").value)
+      assert_equal(%q{<root a="'"/>}, doc.to_s)
+    end
+
     def test_ticket_127
       doc = Document.new
       doc.add_element 'a', { 'v' => 'x & y' }
Index: ruby-2.5.9/test/rexml/test_attributes_mixin.rb
===================================================================
--- ruby-2.5.9.orig/test/rexml/test_attributes_mixin.rb
+++ ruby-2.5.9/test/rexml/test_attributes_mixin.rb
@@ -1,6 +1,4 @@
 # frozen_string_literal: false
-require 'test/unit'
-require 'rexml/document'
 
 module REXMLTests
   class TestAttributes < Test::Unit::TestCase
Index: ruby-2.5.9/test/rexml/test_comment.rb
===================================================================
--- ruby-2.5.9.orig/test/rexml/test_comment.rb
+++ ruby-2.5.9/test/rexml/test_comment.rb
@@ -1,7 +1,4 @@
 # frozen_string_literal: false
-require "test/unit/testcase"
-
-require 'rexml/document'
 
 module REXMLTests
   class CommentTester < Test::Unit::TestCase
Index: ruby-2.5.9/test/rexml/test_contrib.rb
===================================================================
--- ruby-2.5.9.orig/test/rexml/test_contrib.rb
+++ ruby-2.5.9/test/rexml/test_contrib.rb
@@ -1,15 +1,14 @@
 # coding: binary
 # frozen_string_literal: false
 
-require_relative "rexml_test_utils"
-
-require "rexml/document"
 require "rexml/parseexception"
 require "rexml/formatters/default"
 
+require_relative "helper"
+
 module REXMLTests
   class ContribTester < Test::Unit::TestCase
-    include REXMLTestUtils
+    include Helper::Fixture
     include REXML
 
     XML_STRING_01 = <<DELIMITER
@@ -73,6 +72,7 @@ DELIMITER
          >
          ]
        >
+       <svg/>
       EOF
       doc = REXML::Document.new source
       doc.write(out="")
@@ -82,7 +82,7 @@ DELIMITER
 
     # Peter Verhage
     def test_namespace_Peter
-      source = <<-EOF
+      source = <<~EOF
       <?xml version="1.0"?>
       <config:myprog-config xmlns:config="http://someurl/program/version">
       <!-- main options -->
@@ -379,7 +379,7 @@ EOF
     end
 
     def test_entities_Holden_Glova
-      document = <<-EOL
+      document = <<~EOL
       <?xml version="1.0" encoding="UTF-8"?>
       <!DOCTYPE rubynet [
       <!ENTITY rbconfig.MAJOR "1">
Index: ruby-2.5.9/test/rexml/test_core.rb
===================================================================
--- ruby-2.5.9.orig/test/rexml/test_core.rb
+++ ruby-2.5.9/test/rexml/test_core.rb
@@ -1,8 +1,6 @@
-# coding: utf-8
+# -*- coding: utf-8 -*-
 # frozen_string_literal: false
 
-require_relative "rexml_test_utils"
-
 require "rexml/document"
 require "rexml/parseexception"
 require "rexml/output"
@@ -11,13 +9,14 @@ require "rexml/formatters/pretty"
 require "rexml/undefinednamespaceexception"
 
 require_relative "listener"
+require_relative "helper"
 
 module REXMLTests
   class Tester < Test::Unit::TestCase
-    include REXMLTestUtils
+    include Helper::Fixture
     include REXML
     def setup
-      @xsa_source = <<-EOL
+      @xsa_source = <<~EOL
         <?xml version="1.0"?>
         <?xsl stylesheet="blah.xsl"?>
         <!-- The first line tests the XMLDecl, the second tests PI.
@@ -91,7 +90,7 @@ module REXMLTests
 
       # Bryan Murphy <murphybryanp@yahoo.com>
       text = "this is a {target[@name='test']/@value} test"
-      source = <<-EOL
+      source = <<~EOL
       <?xml version="1.0"?>
       <doc search="#{text}"/>
       EOL
@@ -116,6 +115,72 @@ module REXMLTests
         name4='test4'/>).join(' '), e.to_s
     end
 
+    def test_attribute_duplicated
+      # https://www.w3.org/TR/xml-names/#uniqAttrs
+      message = <<-MESSAGE.chomp
+Duplicate attribute "a"
+Line: 2
+Position: 24
+Last 80 unconsumed characters:
+/>
+      MESSAGE
+      assert_raise(REXML::ParseException.new(message)) do
+        Document.new(<<-XML)
+<x>
+  <bad a="1" a="2"/>
+</x>
+        XML
+      end
+    end
+
+    def test_attribute_namespace_conflict
+      # https://www.w3.org/TR/xml-names/#uniqAttrs
+      message = <<-MESSAGE.chomp
+Namespace conflict in adding attribute "a": Prefix "n1" = "http://www.w3.org" and prefix "n2" = "http://www.w3.org"
+Line: 4
+Position: 140
+Last 80 unconsumed characters:
+/>
+      MESSAGE
+      assert_raise(REXML::ParseException.new(message)) do
+        Document.new(<<-XML)
+<!-- http://www.w3.org is bound to n1 and n2 -->
+<x xmlns:n1="http://www.w3.org"
+   xmlns:n2="http://www.w3.org">
+  <bad n1:a="1" n2:a="2"/>
+</x>
+        XML
+      end
+    end
+
+    def test_attribute_default_namespace
+      # https://www.w3.org/TR/xml-names/#uniqAttrs
+      document = Document.new(<<-XML)
+<!-- http://www.w3.org is bound to n1 and is the default -->
+<x xmlns:n1="http://www.w3.org"
+   xmlns="http://www.w3.org" >
+  <good a="1"     b="2" />
+  <good a="1"     n1:a="2" />
+</x>
+      XML
+      attributes = document.root.elements.collect do |element|
+        element.attributes.each_attribute.collect do |attribute|
+          [attribute.prefix, attribute.namespace, attribute.name]
+        end
+      end
+      assert_equal([
+                     [
+                       ["", "", "a"],
+                       ["", "", "b"],
+                     ],
+                     [
+                       ["", "", "a"],
+                       ["n1", "http://www.w3.org", "a"],
+                     ],
+                   ],
+                   attributes)
+    end
+
     def test_cdata
       test = "The quick brown fox jumped
         & < & < \" '
@@ -681,7 +746,7 @@ module REXMLTests
       koln_iso_8859_1 = "K\xF6ln"
       koln_utf8 = "K\xc3\xb6ln"
       source = Source.new( koln_iso_8859_1, 'iso-8859-1' )
-      results = source.scan(/.*/)[0]
+      results = source.match(/.*/)[0]
       koln_utf8.force_encoding('UTF-8') if koln_utf8.respond_to?(:force_encoding)
       assert_equal koln_utf8, results
       output << results
@@ -779,7 +844,7 @@ module REXMLTests
     end
 
     def test_whitespace_before_root
-      a = <<EOL
+      a = <<EOL.chomp
 <?xml version='1.0'?>
   <blo>
     <wak>
@@ -823,7 +888,7 @@ EOL
       assert_equal 'two', doc.root.elements[1].namespace
       assert_equal 'foo', doc.root.namespace
 
-      doc = Document.new <<-EOL
+      doc = Document.new <<~EOL
       <?xml version="1.0"?>
       <!DOCTYPE schema SYSTEM "XMLSchema.dtd" [
       <!ENTITY % p ''>
@@ -877,18 +942,18 @@ EOL
       EOL
 
       # The most common case.  People not caring about the namespaces much.
-      assert_equal( "XY", XPath.match( doc, "/test/a/text()" ).join )
-      assert_equal( "XY", XPath.match( doc, "/test/x:a/text()" ).join )
+      assert_equal( "XY", XPath.match( doc, "/*:test/*:a/text()" ).join )
+      assert_equal( "XY", XPath.match( doc, "/*:test/x:a/text()" ).join )
       # Surprising?  I don't think so, if you believe my definition of the "common case"
-      assert_equal( "XYZ", XPath.match( doc, "//a/text()" ).join )
+      assert_equal( "XYZ", XPath.match( doc, "//*:a/text()" ).join )
 
       # These are the uncommon cases.  Namespaces are actually important, so we define our own
       # mappings, and pass them in.
       assert_equal( "XY", XPath.match( doc, "/f:test/f:a/text()", { "f" => "1" } ).join )
       # The namespaces are defined, and override the original mappings
-      assert_equal( "", XPath.match( doc, "/test/a/text()", { "f" => "1" } ).join )
+      assert_equal( "XY", XPath.match( doc, "/*:test/*:a/text()", { "f" => "1" } ).join )
       assert_equal( "", XPath.match( doc, "/x:test/x:a/text()", { "f" => "1" } ).join )
-      assert_equal( "", XPath.match( doc, "//a/text()", { "f" => "1" } ).join )
+      assert_equal( "XYZ", XPath.match( doc, "//*:a/text()", { "f" => "1" } ).join )
     end
 
     def test_processing_instruction
@@ -900,7 +965,7 @@ EOL
     end
 
     def test_oses_with_bad_EOLs
-      Document.new("\n\n\n<?xml version='1.0'?>\n\n\n<a/>\n\n")
+      Document.new("<?xml version='1.0'?>\n\n\n<a/>\n\n")
     end
 
     # Contributed (with patch to fix bug) by Kouhei
@@ -927,7 +992,7 @@ EOL
     end
 
     def test_hyphens_in_doctype
-      doc = REXML::Document.new <<-EOQ
+      doc = REXML::Document.new <<~EOQ
        <?xml version="1.0"?>
        <!DOCTYPE a-b-c>
        <a-b-c>
@@ -1043,7 +1108,7 @@ EOL
     def test_text_raw
       # From the REXML tutorial
       # (http://www.germane-software.com/software/rexml/test/data/tutorial.html)
-      doc = Document.new <<-EOL
+      doc = Document.new <<~EOL
       <?xml version="1.0"?>
       <!DOCTYPE schema SYSTEM "XMLSchema.dtd" [
       <!ENTITY % s 'Sean'>
@@ -1277,11 +1342,26 @@ EOL
       exception = assert_raise(ParseException) do
         Document.new(src)
       end
-      assert_equal(<<-DETAIL, exception.to_s)
+      assert_equal(<<-DETAIL.chomp, exception.to_s)
 Missing attribute value start quote: <bar>
 Line: 1
 Position: 16
 Last 80 unconsumed characters:
+value/>
+      DETAIL
+    end
+
+    def test_parse_exception_on_missing_attribute_end_quote
+      src = '<foo bar="value/>'
+      exception = assert_raise(ParseException) do
+        Document.new(src)
+      end
+      assert_equal(<<-DETAIL.chomp, exception.to_s)
+Missing attribute value end quote: <bar>: <">
+Line: 1
+Position: 17
+Last 80 unconsumed characters:
+value/>
       DETAIL
     end
 
@@ -1377,7 +1457,7 @@ ENDXML
       d.root.add_element( "bah" )
       p=REXML::Formatters::Pretty.new(2)
       p.compact = true    # Don't add whitespace to text nodes unless necessary
-      p.write(d,out="")
+      p.write(d,out=+"")
       assert_equal( expected, out )
     end
 
@@ -1391,8 +1471,8 @@ ENDXML
 
     def test_ticket_102
       doc = REXML::Document.new '<doc xmlns="ns"><item name="foo"/></doc>'
-      assert_equal( "foo", doc.root.elements["item"].attribute("name","ns").to_s )
-      assert_equal( "item", doc.root.elements["item[@name='foo']"].name )
+      assert_equal( "foo", doc.root.elements["*:item"].attribute("name","ns").to_s )
+      assert_equal( "item", doc.root.elements["*:item[@name='foo']"].name )
     end
 
     def test_ticket_14
@@ -1421,11 +1501,11 @@ ENDXML
       doc = REXML::Document.new(
         '<doc xmlns="ns" xmlns:phantom="ns"><item name="foo">text</item></doc>'
       )
-      assert_equal 'text', doc.text( "/doc/item[@name='foo']" )
+      assert_equal 'text', doc.text( "/*:doc/*:item[@name='foo']" )
       assert_equal "name='foo'",
-        doc.root.elements["item"].attribute("name", "ns").inspect
+        doc.root.elements["*:item"].attribute("name", "ns").inspect
       assert_equal "<item name='foo'>text</item>",
-        doc.root.elements["item[@name='foo']"].to_s
+        doc.root.elements["*:item[@name='foo']"].to_s
     end
 
     def test_ticket_135
@@ -1453,8 +1533,10 @@ ENDXML
           "" => attribute("version", "1.0"),
         },
       }
-      assert_equal(expected, doc.root.attributes)
-      assert_equal(expected, REXML::Document.new(doc.root.to_s).root.attributes)
+      assert_equal(expected,
+                   doc.root.attributes.to_h)
+      assert_equal(expected,
+                   REXML::Document.new(doc.root.to_s).root.attributes.to_h)
     end
 
     def test_empty_doc
Index: ruby-2.5.9/test/rexml/test_doctype.rb
===================================================================
--- ruby-2.5.9.orig/test/rexml/test_doctype.rb
+++ ruby-2.5.9/test/rexml/test_doctype.rb
@@ -1,6 +1,4 @@
 # frozen_string_literal: false
-require 'test/unit'
-require 'rexml/document'
 
 module REXMLTests
   class TestDocTypeAccessor < Test::Unit::TestCase
@@ -41,6 +39,12 @@ module REXMLTests
                    @doc_type_public_system.to_s)
     end
 
+    def test_to_s_apostrophe
+      @doc_type_public_system.parent.context[:prologue_quote] = :apostrophe
+      assert_equal("<!DOCTYPE root PUBLIC '#{@pubid}' '#{@sysid}'>",
+                   @doc_type_public_system.to_s)
+    end
+
     def test_system
       assert_equal([
                      @sysid,
@@ -82,6 +86,35 @@ module REXMLTests
             assert_equal("<!DOCTYPE root SYSTEM \"root.dtd\">",
                          doctype.to_s)
           end
+
+          def test_to_s_apostrophe
+            doctype = REXML::DocType.new(["root", "SYSTEM", nil, "root.dtd"])
+            doc = REXML::Document.new
+            doc << doctype
+            doctype.parent.context[:prologue_quote] = :apostrophe
+            assert_equal("<!DOCTYPE root SYSTEM 'root.dtd'>",
+                         doctype.to_s)
+          end
+
+          def test_to_s_single_quote_apostrophe
+            doctype = REXML::DocType.new(["root", "SYSTEM", nil, "root'.dtd"])
+            doc = REXML::Document.new
+            doc << doctype
+            # This isn't used.
+            doctype.parent.context[:prologue_quote] = :apostrophe
+            assert_equal("<!DOCTYPE root SYSTEM \"root'.dtd\">",
+                         doctype.to_s)
+          end
+
+          def test_to_s_double_quote
+            doctype = REXML::DocType.new(["root", "SYSTEM", nil, "root\".dtd"])
+            doc = REXML::Document.new
+            doc << doctype
+            # This isn't used.
+            doctype.parent.context[:prologue_quote] = :apostrophe
+            assert_equal("<!DOCTYPE root SYSTEM 'root\".dtd'>",
+                         doctype.to_s)
+          end
         end
       end
 
@@ -92,6 +125,25 @@ module REXMLTests
             assert_equal("<!DOCTYPE root PUBLIC \"pub\" \"root.dtd\">",
                          doctype.to_s)
           end
+
+          def test_to_s_apostrophe
+            doctype = REXML::DocType.new(["root", "PUBLIC", "pub", "root.dtd"])
+            doc = REXML::Document.new
+            doc << doctype
+            doctype.parent.context[:prologue_quote] = :apostrophe
+            assert_equal("<!DOCTYPE root PUBLIC 'pub' 'root.dtd'>",
+                         doctype.to_s)
+          end
+
+          def test_to_s_apostrophe_include_apostrophe
+            doctype = REXML::DocType.new(["root", "PUBLIC", "pub'", "root.dtd"])
+            doc = REXML::Document.new
+            doc << doctype
+            # This isn't used.
+            doctype.parent.context[:prologue_quote] = :apostrophe
+            assert_equal("<!DOCTYPE root PUBLIC \"pub'\" 'root.dtd'>",
+                         doctype.to_s)
+          end
         end
 
         class TestSystemLiteral < self
@@ -101,6 +153,25 @@ module REXMLTests
                          doctype.to_s)
           end
 
+          def test_to_s_apostrophe
+            doctype = REXML::DocType.new(["root", "PUBLIC", "pub", "root.dtd"])
+            doc = REXML::Document.new
+            doc << doctype
+            doctype.parent.context[:prologue_quote] = :apostrophe
+            assert_equal("<!DOCTYPE root PUBLIC 'pub' 'root.dtd'>",
+                         doctype.to_s)
+          end
+
+          def test_to_s_apostrophe_include_apostrophe
+            doctype = REXML::DocType.new(["root", "PUBLIC", "pub", "root'.dtd"])
+            doc = REXML::Document.new
+            doc << doctype
+            # This isn't used.
+            doctype.parent.context[:prologue_quote] = :apostrophe
+            assert_equal("<!DOCTYPE root PUBLIC 'pub' \"root'.dtd\">",
+                         doctype.to_s)
+          end
+
           def test_to_s_double_quote
             doctype = REXML::DocType.new(["root", "PUBLIC", "pub", "root\".dtd"])
             assert_equal("<!DOCTYPE root PUBLIC \"pub\" 'root\".dtd'>",
@@ -143,6 +214,62 @@ module REXMLTests
                    decl(@id, "system\"literal").to_s)
     end
 
+    def test_to_s_apostrophe
+      document = REXML::Document.new(<<-XML)
+      <!DOCTYPE root SYSTEM "urn:x-test:sysid" [
+        #{decl(@id, @uri).to_s}
+      ]>
+      <root/>
+      XML
+      document.context[:prologue_quote] = :apostrophe
+      notation = document.doctype.notations[0]
+      assert_equal("<!NOTATION #{@name} PUBLIC '#{@id}' '#{@uri}'>",
+                   notation.to_s)
+    end
+
+    def test_to_s_apostrophe_pubid_literal_include_apostrophe
+      document = REXML::Document.new(<<-XML)
+      <!DOCTYPE root SYSTEM "urn:x-test:sysid" [
+        #{decl("#{@id}'", @uri).to_s}
+      ]>
+      <root/>
+      XML
+      # This isn't used for PubidLiteral because PubidChar includes '.
+      document.context[:prologue_quote] = :apostrophe
+      notation = document.doctype.notations[0]
+      assert_equal("<!NOTATION #{@name} PUBLIC \"#{@id}'\" '#{@uri}'>",
+                   notation.to_s)
+    end
+
+    def test_to_s_apostrophe_system_literal_include_apostrophe
+      document = REXML::Document.new(<<-XML)
+      <!DOCTYPE root SYSTEM "urn:x-test:sysid" [
+        #{decl(@id, "system'literal").to_s}
+      ]>
+      <root/>
+      XML
+      # This isn't used for SystemLiteral because SystemLiteral includes '.
+      document.context[:prologue_quote] = :apostrophe
+      notation = document.doctype.notations[0]
+      assert_equal("<!NOTATION #{@name} PUBLIC '#{@id}' \"system'literal\">",
+                   notation.to_s)
+    end
+
+    def test_to_s_apostrophe_system_literal_include_double_quote
+      document = REXML::Document.new(<<-XML)
+      <!DOCTYPE root SYSTEM "urn:x-test:sysid" [
+        #{decl(@id, "system\"literal").to_s}
+      ]>
+      <root/>
+      XML
+      # This isn't used for SystemLiteral because SystemLiteral includes ".
+      # But quoted by ' because SystemLiteral includes ".
+      document.context[:prologue_quote] = :apostrophe
+      notation = document.doctype.notations[0]
+      assert_equal("<!NOTATION #{@name} PUBLIC '#{@id}' 'system\"literal'>",
+                   notation.to_s)
+    end
+
     private
     def decl(id, uri)
       REXML::NotationDecl.new(@name, "PUBLIC", id, uri)
@@ -170,6 +297,48 @@ module REXMLTests
                    decl("#{@id}\"").to_s)
     end
 
+    def test_to_s_apostrophe
+      document = REXML::Document.new(<<-XML)
+      <!DOCTYPE root SYSTEM "urn:x-test:sysid" [
+        #{decl(@id).to_s}
+      ]>
+      <root/>
+      XML
+      document.context[:prologue_quote] = :apostrophe
+      notation = document.doctype.notations[0]
+      assert_equal("<!NOTATION #{@name} SYSTEM '#{@id}'>",
+                   notation.to_s)
+    end
+
+    def test_to_s_apostrophe_include_apostrophe
+      document = REXML::Document.new(<<-XML)
+      <!DOCTYPE root SYSTEM "urn:x-test:sysid" [
+        #{decl("#{@id}'").to_s}
+      ]>
+      <root/>
+      XML
+      # This isn't used for SystemLiteral because SystemLiteral includes '.
+      document.context[:prologue_quote] = :apostrophe
+      notation = document.doctype.notations[0]
+      assert_equal("<!NOTATION #{@name} SYSTEM \"#{@id}'\">",
+                   notation.to_s)
+    end
+
+    def test_to_s_apostrophe_include_double_quote
+      document = REXML::Document.new(<<-XML)
+      <!DOCTYPE root SYSTEM "urn:x-test:sysid" [
+        #{decl("#{@id}\"").to_s}
+      ]>
+      <root/>
+      XML
+      # This isn't used for SystemLiteral because SystemLiteral includes ".
+      # But quoted by ' because SystemLiteral includes ".
+      document.context[:prologue_quote] = :apostrophe
+      notation = document.doctype.notations[0]
+      assert_equal("<!NOTATION #{@name} SYSTEM '#{@id}\"'>",
+                   notation.to_s)
+    end
+
     private
     def decl(id)
       REXML::NotationDecl.new(@name, "SYSTEM", nil, id)
